# [EDD All Access](https://easydigitaldownloads.com) #

### Welcome to the GitHub Repository for the "All Access" extension for Easy Digital Downloads

When your customers purchase an “All Access” membership product from your digital shop, all “Buy Now” buttons on your website will automatically turn into “Download” buttons for that customer.

To set-up:
Step 1. Create a new product by going to “Downloads” > “Add New”.
Step 2: On the right side, check the box called “Enable All Access”.
Step 3: Select additional options to restrict the customers downloads per day, which categories they can download from, and when their access expires.

Because you can restrict access by category, you can bundle tens, hundreds, or even hundreds of thousands of products together in mere seconds. If you already have a complex store with many products, it is just as easy to implement as if you are setting up a brand new store.

### Sync with Recurring to sell All Access Memberships:
To sell on-going, recurring “All Access” memberships to your customers, use the EDD Recurring extension alongside this extension. For your All Access products, simple check the option to enable “Recurring”, set the recurring period, and under the “All Access” options, set the expiration time to “Sync with Recurring expiration”.

### Sync with Software Licensing to sell “Master” licenses:
If you use our Software Licensing extension and sell licensed software, All Access will allow you to sell a “Master License” that works for all of your products. So, not only can your “All Access” customers log into your site to download any of your software, they can also use their “All Access” license for any product. This removes a lot of frustration for users who dislike remembering many different license keys and expiration dates. They only have to remember to renew a single license every year. 1 license, 1 expiration date, any product. This improves their user experience immensely.

### Sync with Commissions:
If your site sells products from many different creators, you may wish to pay them based on which products are downloaded by your customers. By using this plugin with the EDD Commissions plugin, you can make that happen! It uses an algorithm that is a little bit complex to understand - but easy once you go through it, it makes sense. Basically, when a customer’s All Access period ends, the plugin takes a look at ALL the products that customer downloaded in that period. It will split the money earned from the original All Access purchase between all the creators whose products were downloaded by the customer. The way it splits the cost between creators is “weighted” based on the “actual” cost of the products they downloaded. For example, if a customer pays $100 for All Access for 30 days and downloads 10 differently-valued photos from 10 different creators, at the end of 30 days it triggers the creation of commissions like this:

1. It adds up the “actual” cost of each downloaded item (as if they were all bought individually).
2. For each downloaded item, it divides the “actual” cost by the total value from step 1. This tells us the percentage of the total that each file download is worth.
3. Using that percentage, it then splits the $100 that All Access cost between all vendors.

Note that Vendors will not be paid until the end of a customers All Access period. Therefore, your store will want to make sure to keep commission-payable funds from a customer available until the end of each customers All Access period.

More information can be found at [easydigitaldownloads.com/downloads/edd-all-access](https://easydigitaldownloads.com/downloads/edd-all-access).

## Installation ##

Step 1. Create a new product by going to “Downloads” > “Add New”.
Step 2: On the right side, check the box called “Enable All Access”.
Step 3: Select additional options to restrict the customers downloads per day, which categories they can download from, and when their access expires.

For more detailed setup instructions, visit the official [Documentation](https://easydigitaldownloads.com/documentation/) page.

1. You can clone the GitHub repository: `https://github.com/easydigitaldownloads/edd-all-access.git`
2. Or download it directly as a ZIP file: `https://github.com/easydigitaldownloads/edd-all-access/archive/master.zip`

This will download the latest developer copy of the All Access extension for Easy Digital Downloads.

## Bugs ##
If you find an issue, let us know [here](https://github.com/easydigitaldownloads/edd-all-access/issues?state=open)!

## Support ##
This is a developer's portal for Easy Digital Downloads and should _not_ be used for support. Please visit Easy Digital Downloads [Support](https://easydigitaldownloads.com/support).

## Contributions ##
Anyone is welcome to contribute to the All Access extension for Easy Digital Downloads. Please read the [guidelines for contributing](https://github.com/easydigitaldownloads/edd-all-access/blob/master/CONTRIBUTING.md) to this repository.

There are various ways you can contribute:

1. Raise an [Issue](https://github.com/easydigitaldownloads/edd-all-access/issues) on GitHub
2. Send us a Pull Request with your bug fixes and/or new features
3. Translate this extension into [different languages](http://docs.easydigitaldownloads.com/article/1023-translating-easy-digital-downloads)
4. Provide feedback and suggestions on [enhancements](https://github.com/easydigitaldownloads/edd-all-access/issues?direction=desc&labels=Enhancement&page=1&sort=created&state=open)
