jQuery(document).ready(function($) {
	// Commissions Integration Script:

	$.fn.edd_all_access_commissions_show_hide = function() {

		// If All Access is enabled
		if( $( "#edd_all_access_enabled" ).is( ':checked' ) ){
			// Hide the All Access Child Note in the Commissions metabox
			$( "#eddc_all_access_child_note" ).hide();
		}
		else{
			// Show the All Access Child Note in the Commissions metabox
			$( "#eddc_all_access_child_note" ).show();
		}

		if( $( "#edd_commisions_enabled" ).is( ':checked' ) ){
			// If All Access enabled AND Commissions set to use All Access for splitting, hide un-needed Commissions Options
			if( $( "#edd_all_access_enabled" ).is( ':checked' ) && $( 'input[name="edd_commission_settings[type]"]:checked' ).val() == 'all_access' ){

				// First we will replace the normal class names for commissions options so they come under the All Access Control checkbox instead.
				$( '.eddc_toggled_row' ).addClass( 'eddc_all_access_toggled_row' );
				$( '.eddc_all_access_toggled_row' ).removeClass( 'eddc_toggled_row' );

				// Shipping/Commissions integration settings
				$( '#edd_commissions_shipping_fee_split' ).attr( 'id', 'eddc_shipping_fee_split_all_access_toggled_row' );
				// Recurring/Commissions integration settings
				$( '#edd_commissions_recurring' ).attr( 'id', 'eddc_recurring_all_access_toggled_row' );

				// Hide unneeded commissions metabox options
				$( '#edd_download_commissions #eddc_commission_rates_wrapper' ).hide();
				$( '#eddc_recurring_all_access_toggled_row' ).hide();
				$( '#eddc_shipping_fee_split_all_access_toggled_row' ).hide();

			}else{
				// First we will re-replace the normal class names for commissions options so they come back under the Commissions enabled checkbox instead.
				$( '.eddc_all_access_toggled_row' ).addClass( 'eddc_toggled_row' );
				$( '.eddc_toggled_row' ).removeClass( 'eddc_all_access_toggled_row' );

				// Shipping/Commissions integration settings
				$( '#eddc_shipping_fee_split_all_access_toggled_row' ).attr( 'id', 'edd_commissions_shipping_fee_split' );
				// Recurring/Commissions integration settings
				$( '#eddc_recurring_all_access_toggled_row' ).attr( 'id', 'edd_commissions_recurring' );

				// Show them again
				if ( $( "#edd_commisions_enabled" ).is( ':checked' ) ){
					$( '#edd_download_commissions #eddc_commission_rates_wrapper' ).show();
					$( '#edd_commissions_shipping_fee_split' ).show();
					$( '#edd_commissions_recurring' ).show();
				}

			}
		}

		return this;
	}

	// Trigger whether the "All Access" Commissions split is shown or not based on whether All Access is enabled or not
	$.fn.edd_all_access_commissions_show_hide_upon_checks = function() {


		// If Commissions are not enabled, don't make any changes in the commissions metabox
		if( $( "#edd_all_access_enabled" ).is( ':checked' ) && $( "#edd_commisions_enabled" ).is( ':checked' ) ){

			// When All Access is enabled, automatically show and check the "All Access" option for commissions splitting
			$( "#edd_download_commissions #eddc_type_all_access_wrapper" ).show();

		}else{

			// When All Access is unchecked, automatically hide the All Access option and auto check the "Percentage" option for commissions splitting.
			$( "#edd_download_commissions #eddc_type_all_access_wrapper" ).hide();

		}


	}

	// Auto-Check "All Access calculates split" when All Access is enabled. And vice versa, change it to be "percentage" when All Access is disabled.
	$( document ).on( 'click change', "#edd_all_access_enabled", function( event ){

		// If All Access was just enabled auto-check the "All Access calculates split" option.
		if( $( "#edd_all_access_enabled" ).is( ':checked' ) ){

			$( "#edd_download_commissions input[value='all_access']" ).prop("checked", true);

		}else{

			// If Commissions or All Access were just disabled
			$( "#edd_download_commissions input[value='percentage']" ).prop("checked", true);
		}

	});

	$( document ).on( 'click change', "#edd_all_access_enabled, #edd_commisions_enabled", function( event ){
		$( document ).edd_all_access_commissions_show_hide_upon_checks();
	});

	// Trigger the show/hide function for commissions settings
	$( document ).on( 'click change', "#edd_commisions_enabled, #edd_all_access_enabled, input[name='edd_commission_settings[type]']", function( event ){
		$( document ).edd_all_access_commissions_show_hide();
	});

	// Run it on page load to show the field appropriately
	$( document ).edd_all_access_commissions_show_hide();
	$( document ).edd_all_access_commissions_show_hide_upon_checks();
});
