jQuery(document).ready(function($) {
	/**
	 * EDD Tools Page: Migrate RCP Members to All Access
	 */
	var EDD_All_Access_Migrate_RCP_Members = {

		init : function() {
			this.submit();
			this.dismiss_message();
		},

		submit : function() {

			var self = this;

			$( document.body ).on( 'submit', '#edd-tools-all-access-rcp-migrate-form', function(e) {
				e.preventDefault();

				var submitButton = $(this).find( 'input[type="submit"]' );

				if ( ! submitButton.hasClass( 'button-disabled' ) ) {

					var data = $(this).serialize();

					submitButton.addClass( 'button-disabled' );
					$(this).find('.notice-wrap').remove();
					$(this).append( '<div class="notice-wrap"><span class="spinner is-active"></span><div class="edd-progress"><div></div></div></div>' );

					// start the process
					self.process_step( 0, data, self );

				}

			});
		},

		process_step : function( step, data, self ) {

			$.ajax({
				type: 'POST',
				url: ajaxurl,
				data: {
					form: data,
					action: 'edd_all_access_do_ajax_rcp_migrate',
					step: step,
				},
				dataType: "json",
				success: function( response ) {

					console.log(response);

					if( 'done' == response.step || response.error || response.success ) {

						var all_access_process_form    = $('#edd-tools-all-access-rcp-migrate-form').find('.edd-progress').parent().parent();
						var notice_wrap    = all_access_process_form.find('.notice-wrap');

						all_access_process_form.find('.button-disabled').removeClass('button-disabled');

						if ( response.error ) {

							var error_message = response.message;
							notice_wrap.html('<div class="updated error"><p>' + error_message + '</p></div>');

						} else if ( response.success ) {

							var success_message = response.message;
							notice_wrap.html('<div id="edd-all-access-process-success" class="updated notice is-dismissible"><p>' + success_message + '<span class="notice-dismiss"></span></p></div>');

						} else {

							notice_wrap.remove();
							window.location = response.url;

						}

					} else {
						$('#edd-tools-all-access-rcp-migrate-form .edd-progress div').animate({
							width: response.percentage + '%',
						}, 50, function() {
							// Animation complete.
						});
						self.process_step( parseInt( response.step ), data, self );
					}

				}
			}).fail(function (response) {
				if ( window.console && window.console.log ) {
					console.log( response );
				}
			});

		},

		dismiss_message : function() {
			$('body').on( 'click', '#edd-all-access-process-success .notice-dismiss', function() {
				$('#edd-all-access-process-success').parent().slideUp('fast');
			});
		}

	};
	EDD_All_Access_Migrate_RCP_Members.init();
});
