jQuery(document).ready(function($){

	/**
	 * Show or hide the expiration options for All Access
	 */
	$.fn.edd_all_access_duration_update = function(){

		var duration_unit = $( '#edd_all_access_meta_all_access_duration_unit' ).val();

		//If the duration is set to anything other than "Never Expires"
		if ( duration_unit == 'year' || duration_unit == 'month' || duration_unit == 'week' || duration_unit == 'day' ){
			$( '#edd_all_access_meta_all_access_duration_number' ).show();
		}else{
			$( '#edd_all_access_meta_all_access_duration_number' ).hide();
		}

	}

	/**
	 * Show or hide the download limit options
	 */
	$.fn.edd_all_access_download_limit_update = function(){

		//Temporarily hide the download time period select field
		$(".edd_all_access_download_limit_time_period").hide();

		//If the number entered into the download limit field is greater than 0, show the download limit time period field
		if ( $(' #edd_all_access_download_limit').val() > 0 ){

			//Loop through each option in the download limit time period field to make it say "X Downloads Per Y" where X is the value in the Download Limit Field.
			$("#edd_all_access_meta_download_limit_time_period option").each( function( index, value ) {
				$(this).html( $("#edd_all_access_download_limit").val() + " " + $(this).html().substr($(this).html().indexOf(" ")+1) );
			});

			// Show the Download Limit TIme Period select input
			$("#edd_all_access_meta_download_limit_time_period").show();

			// Hide the note that says "Unlimited" when the limit is set to 0
			$("#edd_all_access_unlimited_download_limit_note").hide();

		}else{
			// Hide the Download Limit TIme Period select input
			$("#edd_all_access_meta_download_limit_time_period").hide();
			// Show the note that says "Unlimited" when the limit is set to 0
			$("#edd_all_access_unlimited_download_limit_note").show();
		}
	}

	/**
	 * Show or hide the price id setting in the All Access Metabox
	 */
	$.fn.edd_all_access_price_ids_update = function(){

		//Temporarily hide the included price variations field area
		$(".edd_all_access_included_price_ids_row").hide();

		//Temporarily hide the checkboxes containing the included price ids
		$("#edd_all_access_included_price_ids").hide();

		// Temporarily hide the note that displays if the setting is set to 0
		$("#edd_all_access_included_price_ids_note").hide();

		//If the number entered into the price variations field is greater than 0, show the included price variations checkbox fields area
		if ( $('#edd_all_access_number_of_price_ids').val() > 0 ){

			var checkboxes = $( "#edd_all_access_included_price_ids .edd_all_access_included_price_id_li" );
			var number_of_price_ids = parseInt( $("#edd_all_access_number_of_price_ids").val() );
			var number_of_checkboxes = checkboxes.length;
			var number_of_visible_checkboxes = 0;

			checkboxes.each( function( index, element ){
				if ( $(this).css('display') !== 'none' ){
					number_of_visible_checkboxes = number_of_visible_checkboxes + 1;
				}
			});

			//If the number of price ids is greater than the current number of visible checkboxes, add more Price ID checkboxes.
			if ( number_of_price_ids > number_of_visible_checkboxes ){

				//If the number of price ids is greater than the current number of checkboxes, add more Price ID checkboxes.
				if ( number_of_price_ids > number_of_checkboxes ){
					//Get the difference in number
					var number_of_new_checkboxes_needed = number_of_price_ids - number_of_checkboxes;

					//Add the new checkboxes we need
					for (i = 0; i < number_of_new_checkboxes_needed; i++) {

						var variation_number = number_of_price_ids - number_of_new_checkboxes_needed + i + 1;

						$( '#edd_all_access_included_price_ids .edd_all_access_included_price_id_li' ).show();

						if ( variation_number == 1 ){
							$( '#edd_all_access_included_price_ids' ).append( '<li class="edd_all_access_included_price_id_li ' + variation_number + '"><input type="checkbox" name="edd_all_access_meta[included_price_ids][]" class="edd_all_access_included_price_id" value="' +  variation_number + '">' + variation_number + edd_all_access_vars.first_variation_string +' &nbsp;</li>' );
						}else if( variation_number == 2 ){
							$( '#edd_all_access_included_price_ids' ).append( '<li class="edd_all_access_included_price_id_li ' + variation_number + '"><input type="checkbox" name="edd_all_access_meta[included_price_ids][]" class="edd_all_access_included_price_id" value="' +  variation_number + '">' + variation_number + edd_all_access_vars.second_variation_string +' &nbsp;</li>' );
						}else if( variation_number == 3 ){
							$( '#edd_all_access_included_price_ids' ).append( '<li class="edd_all_access_included_price_id_li ' + variation_number + '"><input type="checkbox" name="edd_all_access_meta[included_price_ids][]" class="edd_all_access_included_price_id" value="' +  variation_number + '">' + variation_number + edd_all_access_vars.third_variation_string +' &nbsp;</li>' );
						}else{
							$( '#edd_all_access_included_price_ids' ).append( '<li class="edd_all_access_included_price_id_li ' + variation_number + '"><input type="checkbox" name="edd_all_access_meta[included_price_ids][]" class="edd_all_access_included_price_id" value="' +  variation_number + '">' + variation_number + edd_all_access_vars.variation_string +' &nbsp;</li>' );
						}

					}
				}
				//Rather than adding new checkboxes, just show the hidden ones
				else{
					//Get the difference in number
					var number_of_new_checkboxes_needed = number_of_price_ids - number_of_visible_checkboxes;

					//Show the checkboxes we need
					for (i = 0; i < number_of_new_checkboxes_needed; i++) {

						var variation_number = number_of_price_ids - number_of_new_checkboxes_needed + i + 1;

						$( '#edd_all_access_included_price_ids .edd_all_access_included_price_id_li.' + variation_number ).show();

					}
				}
			}
			//If the number of price ids is less than the number of checkboxes, hide any extra checkboxes
			else{

				//Get the difference in number
				var number_of_new_checkboxes_to_hide = number_of_visible_checkboxes - number_of_price_ids;

				for (i = 1; i < (number_of_checkboxes + 1 ); i++) {

					if ( i > number_of_price_ids ){
						$( '#edd_all_access_included_price_ids .edd_all_access_included_price_id_li.' + i ).hide();
					}

				}

			}

			//Show the included price variations field area
			$(".edd_all_access_included_price_ids_row").show();

			//Show the checkboxes containing the included price ids
			$("#edd_all_access_included_price_ids").show();

			//Hide the note that displays if the setting is set to 0
			$("#edd_all_access_included_price_ids_note").hide();

		}else{

			//Hide the included price variations field area
			$(".edd_all_access_included_price_ids_row").hide();

			//Hide the checkboxes containing the included price ids
			$("#edd_all_access_included_price_ids").hide();

			//Show the note that displays if the setting is set to 0
			$("#edd_all_access_included_price_ids_note").show();

		}
	}

	// Show or hide the "Exclude from All Access" checkbox based on whether All Access is enabled for this product.
	$.fn.edd_all_access_exclude_show_hide = function() {

		// If All Access enabled, hide hide exclude checkbox
		if( $( "#edd_all_access_enabled" ).is( ':checked' ) ){

			// Hide the exclude from all access option for single prices
			$( '#edd_all_access_exclude_single_option' ).hide();

			// Hide the exclude from all access options for variable prices
			$( '.edd-all-access-exclude-price-id' ).hide();

			// Hide the table header for exclude from all access options for variable prices
			$( '.edd-all-access-exclude-price-id-header' ).hide();

		}else{

			if ( $( '#edd_variable_pricing' ).is( ':checked' ) ){

				// Hide the exclude from all access option for single prices
				$( '#edd_all_access_exclude_single_option' ).hide();

				// Show the exclude from all access options for variable prices
				$( '.edd-all-access-exclude-price-id' ).show();

				// Show the table header for exclude from all access options for variable prices
				$( '.edd-all-access-exclude-price-id-header' ).show();

			}else{
				// Show the exclude from all access option for single prices
				$( '#edd_all_access_exclude_single_option' ).show();

				// Hide the exclude from all access options for variable prices
				$( '.edd-all-access-exclude-price-id' ).hide();

				// Hide the table header for exclude from all access options for variable prices
				$( '.edd-all-access-exclude-price-id-header' ).hide();
			}


		}

		return this;
	}

	// If both commissions and shipping are enabled, show this option in the commissions metabox
	$( document ).on( 'click change', "#edd_all_access_enabled, #edd_variable_pricing", function( event ){
		$( document ).edd_all_access_exclude_show_hide();
	});

	// Run it on page load to show the field appropriately
	$( document ).edd_all_access_exclude_show_hide();

	/**
	 * EDD Tools Page: Process All Access Passes
	 */
	var EDD_All_Access_Process_All_Access_Passes = {

		init : function() {
			this.submit();
			this.dismiss_message();
		},

		submit : function() {

			var self = this;

			$( document.body ).on( 'submit', '#edd-tools-all-access-process-form', function(e) {
				e.preventDefault();

				var submitButton = $(this).find( 'input[type="submit"]' );

				if ( ! submitButton.hasClass( 'button-disabled' ) ) {

					var data = $(this).serialize();

					submitButton.addClass( 'button-disabled' );
					$(this).find('.notice-wrap').remove();
					$(this).append( '<div class="notice-wrap"><span class="spinner is-active"></span><div class="edd-progress"><div></div></div></div>' );

					// start the process
					self.process_step( 0, data, self );

				}

			});
		},

		process_step : function( step, data, self ) {

			$.ajax({
				type: 'POST',
				url: ajaxurl,
				data: {
					form: data,
					action: 'edd_all_access_do_ajax_process',
					step: step,
				},
				dataType: "json",
				success: function( response ) {

					if( 'done' == response.step || response.error || response.success ) {

						var all_access_process_form    = $('#edd-tools-all-access-process-form').find('.edd-progress').parent().parent();
						var notice_wrap    = all_access_process_form.find('.notice-wrap');

						all_access_process_form.find('.button-disabled').removeClass('button-disabled');

						if ( response.error ) {

							var error_message = response.message;
							notice_wrap.html('<div class="updated error"><p>' + error_message + '</p></div>');

						} else if ( response.success ) {

							var success_message = response.message;
							notice_wrap.html('<div id="edd-all-access-process-success" class="updated notice is-dismissible"><p>' + success_message + '<span class="notice-dismiss"></span></p></div>');

						} else {

							notice_wrap.remove();
							window.location = response.url;

						}

					} else {
						$('#edd-tools-all-access-process-form .edd-progress div').animate({
							width: response.percentage + '%',
						}, 50, function() {
							// Animation complete.
						});
						self.process_step( parseInt( response.step ), data, self );
					}

				}
			}).fail(function (response) {
				if ( window.console && window.console.log ) {
					console.log( response );
				}
			});

		},

		dismiss_message : function() {
			$('body').on( 'click', '#edd-all-access-process-success .notice-dismiss', function() {
				$('#edd-all-access-process-success').parent().slideUp('fast');
			});
		}

	};
	EDD_All_Access_Process_All_Access_Passes.init();

	//Set all Chosen JS for All Access meta options to be 100% width - otherwise they default to 300px
	$('.edd-select-chosen.edd_all_access_meta_all_access_categories').css( 'width', '100%' );

	//When the "All Access" checkbox is clicked on the edit download screen
	$( document ).on( "change", "#edd_all_access_enabled", function(){
		$(".edd_all_access_row").toggle();
		$( document ).edd_all_access_download_limit_update();
	});

	//When the "Duration" time is changed from "Never Expires"
	$(document).on( "change click keyup load", "#edd_all_access_meta_all_access_duration_unit", function(){
		$( document ).edd_all_access_duration_update();
	});

	$( document ).edd_all_access_duration_update();

	//When a number is entered into the Download Limit field
	$(document).on( "change click keyup load", "#edd_all_access_download_limit", function(){
		$( document ).edd_all_access_download_limit_update();
	});

	$( document ).edd_all_access_download_limit_update();

	//When the Number of Included Price IDs changes
	$(document).on( "change click keyup load", "#edd_all_access_number_of_price_ids", function(){
		$( document ).edd_all_access_price_ids_update();
	});

	$( document ).edd_all_access_price_ids_update();

	// On the "Manage" page for an All Access Pass, throw an "Are you Sure" if the edited All Access pass will become expired after update
	edd_aa_manage_update_check_complete = false;
	$( document ).on( 'submit', '#edit-all-access-pass', function( event ){

		// If the checked flag has not been set to true
		if ( ! edd_aa_manage_update_check_complete ){
			event.preventDefault();

			// If the activation meta is selected (as opposed to customer specific meta), no check needs to take place.
			if ( $( '#time_of_activation_meta' ).is(':checked') ){

				edd_aa_manage_update_check_complete = true;
				$( '#edd_update_all_access_pass' ).trigger( 'click' );

			}else{

				// Get the values being saved in the Customer Specific Meta
				start_date = $( '#edd_all_access_meta_all_access_start_date' ).val();
				duration_number = $( '#edd_all_access_meta_all_access_duration_number' ).val();
				duration_unit = $( '#edd_all_access_meta_all_access_duration_unit' ).val();

				// Check if this will be in the future through ajax
				$.ajax({
					type: 'POST',
					url: ajaxurl,
					data: {
						start_date: start_date,
						duration_number: duration_number,
						duration_unit: duration_unit,
						action: 'edd_all_access_expiration_check',
					},
					dataType: "json",
					success: function( response ) {

						// If it would expire
						if ( response.would_expire ){
							// Show the "Are you Sure" popup
							edd_aa_manage_update_check_complete = confirm( edd_all_access_vars.manage_all_access_expire_warning );
							if ( edd_aa_manage_update_check_complete ){
								$( '#edd_update_all_access_pass' ).trigger( 'click' );
							}
						}else{
							//Carry on as normal without an "Are you sure" check.
							edd_aa_manage_update_check_complete = true;
							$( '#edd_update_all_access_pass' ).trigger( 'click' );

						}

					}
				}).fail(function (response) {
					if ( window.console && window.console.log ) {
						console.log( response );
					}
				});
			}
		}
	});

});
