<?php
/**
 * Tools added to the "Tools" page in EDD Settings for EDD All Access.
 *
 * @package     EDD\EDDAllAccess\Functions
 * @since       1.0.0
 */

 // Exit if accessed directly
 if ( ! defined( 'ABSPATH' ) ) {
	 exit;
 }

 /**
  * Display the Process All Access Pass Tool
  *
  * @since       1.0.0
  * @return      void
  */
 function edd_all_access_process_payments_tool_display() {

	 if( ! current_user_can( 'manage_shop_settings' ) ) {
		 return;
	 }

	 do_action( 'edd_tools_recount_stats_before' );
 ?>
	 <div class="postbox">
		 <h3><span><?php _e( 'All Access - Process All Access Passes', 'edd-all-access' ); ?></span></h3>
		 <div class="inside recount-stats-controls">
			 <p><?php echo __( 'Use this tool to appropriately activate/expire All Access Passes for any purchases that took place before the All Access extension was installed. Additionally, if any Payments contained All Access products and were not properly activated/expired for any reason, this tool will put everything into proper sync in regards to All Access. IMPORTANT NOTE: Before you use this tool, make sure that all of your All Access Pass products have been properly set up. To be sure, please review', 'edd-all-access' ) . ' <a href="http://docs.easydigitaldownloads.com/article/1829-all-access-creating-all-access-products" target="_blank">' . __( 'this document.', 'edd-all-access' ) . '</a>'; ?></p>
			 <form method="post" id="edd-tools-all-access-process-form" class="edd-all-access-process-form edd-import-export-form">
				 <span>

					 <?php wp_nonce_field( 'edd_all_access_ajax_process', 'edd_all_access_ajax_process' ); ?>

					 <input type="submit" id="edd-all-access-tool-submit" value="<?php _e( 'Process All Access Passes', 'edd-all-access' ); ?>" class="button-secondary"/>

					 <br />

					 <span class="spinner"></span>

				 </span>
			 </form>
		 </div><!-- .inside -->
	 </div><!-- .postbox -->
 <?php
 }
 add_action( 'edd_tools_tab_general', 'edd_all_access_process_payments_tool_display' );
